#pragma once

#include <cstdint>
#include <string>

namespace Beatsaber {
	namespace BeatmapCharacteristic {
		enum BeatmapCharacteristic : std::uint8_t {
			NONE,
			STANDARD,
			NOARROWS,
			ONESABER,
			DEGREE360,
			DEGREE90,
			LIGHTSHOW,
			LAWLESS,
		};

		const std::string characteristicsName[] {"None", "Standard", "NoArrows", "OneSaber", "360Degree", "90Degree", "Lightshow", "Lawless"};
		const std::uint8_t characteristicsNameSize = sizeof(characteristicsName)/sizeof(std::string);

		BeatmapCharacteristic getByString(const std::string& str);

		const std::string& toString(BeatmapCharacteristic c);
	}
}