 #pragma once

#include <cstdint>
#include <string>

namespace Beatsaber {

struct Note {
	std::uint32_t time; //time in beats when the note reaches the player
	std::uint_fast8_t line; //colum, 0 = most left, 3 = most right
	std::uint_fast8_t layer; //layer 0 = bottom, 2 = top
	std::uint_fast8_t type; //0 = rednote, 1 = bluenote, 2 = unused, 3 = bomb
	std::uint_fast8_t cutdir;
	std::string customdata;
};

struct Wall {
	std::uint32_t time; // time in beats when the note reaches the player
	std::uint_fast8_t line; //0-3, 0 = left, 3 = right
	std::uint_fast8_t type; // 0 = fullhight, 1 = crouch
	std::int32_t duration; //time in beats the wall is there, might be nagtive...
	std::int_fast8_t width; //might be negative (should be between 0-4)
	std::string customdata;
};

}